function C = maskHead(mask)
%maskHead      Refines a binary mask indicating only the biggest connected structure (head).
%
%   C = maskHead(mask) 
%   Refines a binary MASK indicating only the leaving only the biggest connected structure C (head).
%
%   Alonso Ramirez.  
%   $Date: 2008/10/21$

[L,NUM] = bwlabeln(mask);
nvox = 0;
maxidx = 0;
for i=1:NUM % looking for the biggest volume
    sumi = sum(sum(sum(L==i)));
    if  sumi > nvox
        nvox = sumi;
        maxidx=i;
    end
end

C = (L == maxidx);
