function plotContinuosField(fPDD,fAmountDiff,mask,fNDiff)
%plotContinuosField      Use matlab plot for show the multi PDD
%
%   cleanMDT_nTens(inputPath,outputPath,genericName) 
%   Plot the continuous solution depicted by number FNDIFF of diffusion directions, the diffusion directions FPDD, 
%   the amount of each one FAMOUNTDIFF and the activity MASK.
%   Alonso Ramirez.  
%   $Date: 2008/10/21$

[ny,nx,nz,nMaxDifs,dumm] = size(fPDD);

%plot the fields

arrows = zeros(ny,nx,nz,nMaxDifs,3);
arrows(:,:,:,:,1) = squeeze(fPDD(:,:,:,:,1)) .* squeeze(fAmountDiff(:,:,:,:));
arrows(:,:,:,:,2) = squeeze(fPDD(:,:,:,:,2)) .* squeeze(fAmountDiff(:,:,:,:));
arrows(:,:,:,:,3) = squeeze(fPDD(:,:,:,:,3)) .* squeeze(fAmountDiff(:,:,:,:));

maxArrowV =  max(max(max(max(max(arrows)))));


[xx,yy]= meshgrid(1:nx+3 , 1:ny);

for z=1:nz
    if z>2
        hold off;
    end
    figure;    
    
    for n=1:nMaxDifs
        ff1 = zeros(size(xx));
        ff2 = zeros(size(yy));
        
        for x=1:nx
            for y=1:ny
                
                
                if mask(y,x,z) == 1 & n <= fNDiff(y,x,z)

                    
                    if fPDD(y,x,z,n,2) < 0
                        fPDD(y,x,z,n,2) = -fPDD(y,x,z,n,2);
                        fPDD(y,x,z,n,1) = -fPDD(y,x,z,n,1);
                    end
                    
                    ff1(ny-y+1,x) = fPDD(y,x,z,n,1)*fAmountDiff(y,x,z,n); 
                    ff2(ny-y+1,x) = fPDD(y,x,z,n,2)*fAmountDiff(y,x,z,n); 
                end
            end
        end
        %normalize the view
        ff1 = [ff1(:,1:nx) zeros(ny,2) zeros(ny,1)+maxArrowV];
        ff2 = [ff2(:,1:nx) zeros(ny,2) zeros(ny,1)+maxArrowV];
        
        h = quiver(xx,yy,ff1,ff2,1.25,'b'); title('Multi-PDD Field');
        %set(h,'LineWidth',0.2);
        hold on;
        
        
    end

    axis equal
    axis([0 nx+1 0 ny+1])
    axis off    
    
end


hold off;


